import { Machine, State, On, SideEffect, Goto, Spawn, Unspawn, Interpreter, Interpreter_T, send, Event_T } from '../index';

const beginTimer = (ctx:C, e:Event_T, self:Interpreter_T)=>{ setTimeout(()=>{ send(self, ['timer-finished',null]); }, 800); };
const log = (ctx:C, e:Event_T, self:Interpreter_T)=>{ console.log(self.state); };

type S = 
  | 'green' 
  | 'yellow' 
  | 'red';
type E = 
  | ['entry',null] 
  | ['timer-finished',null];
type C = {};

const machine = 
  Machine(
    State('green',
      On('entry', 
        SideEffect(beginTimer),
        SideEffect(log)
      ),
      On('timer-finished',
        Goto('yellow')
      )
    ),
    State('yellow',
      On('entry', 
        SideEffect(beginTimer),
        SideEffect(log)
      ),
      On('timer-finished',
        Goto('red')
      )
    ),
    State('red',
      On('entry', 
        SideEffect(beginTimer),
        SideEffect(log)
      ),
      On('timer-finished',
        Goto('green')
      )
    ),
  );

const actor = Interpreter(machine, {context:{}});